package javaxt.geospatial.geometry;

//******************************************************************************
//**  Box Class - By Peter Borissow
//******************************************************************************
/**
 *   Bounding Box
 *
 ******************************************************************************/

public class Box implements Geometry {
    
    
    private double minX;
    private double minY;
    private double maxX;
    private double maxY;
    
    private String srs = "EPSG:4326";
    
  //**************************************************************************
  //** Creates a new instance of Box
  //**************************************************************************
    
    public Box(double minX, double minY, double maxX, double maxY){
        this.minX = minX;
        this.minY = minY;
        this.maxX = maxX;
        this.maxY = maxY;
    }
    
    public Box(Point min, Point max){
        this.minX = min.x;
        this.minY = min.y;
        this.maxX = max.x;
        this.maxY = max.y;
    }
    
    /*
    public Box(Point Point){
    }
    
    public Box(Line Line){
    }
    
    public Box(Polygon Polygon){
        
    }
    */
    
  //**************************************************************************
  //** getSRS
  //**************************************************************************
  //** Sets the srs attribute for this Geometry. */
    
    public void setSRS(String srsName){
        if (srsName==null) srs = "";
        else srs = srsName.trim();
    }
    
    
  //**************************************************************************
  //** getSRS
  //**************************************************************************
  //** Returns the srs name of this Geometry. */
    
    public String getSRS(){
        return srs;
    }
    
    
  //**************************************************************************
  //** getName
  //**************************************************************************
  /**  Returns the name of this Geometry. */
    
    public String getName(){ 
        return new Geometry.Name(this).toString(); 
    }
    
    
    public String toString(){
        return minX + "," + maxY + " " + //UL
               minX + "," + minY + " " + //LL
               maxX + "," + minY + " " + //LR
               maxX + "," + maxY + " " + //UR
               minX + "," + maxY;
    }
    
  //**************************************************************************
  //** toGML
  //**************************************************************************
  /**  Used to convert a MultiPoint to GML (xml fragment) */
    
    public String toGML(){
        
        String srsName = " srsName=\"" + srs + "\"";
        if (srs.length()==0) srsName = "";
        
        return 
        "<gml:Envelope" + srsName + ">" +
        "<gml:lowerCorner>" + minX + " " + minY + "</gml:lowerCorner>" +
        "<gml:upperCorner>" + maxX + " " + maxY + "</gml:upperCorner>" +
        "</gml:Envelope>";
    }
    
    
    public String toDB2(){
        return "";
    }
    
    public String toSQS(){
        return "";
    }
    
}
